<template>
  <component
    :is="getComponentName(taskInfo.type)"
    :task-info="taskInfo"
    :task="activeTask"
    class="task-monitor-section-wrapper"
    @getTasks="$emit('getTasks')"
  />
</template>

<script>
  import SectionConstructor from '../itemsSections/SectionConstructor'
  import SectionConflict from '../itemsSections/SectionConflict'
  import SectionAssessmentRisk from '../itemsSections/SectionAssessmentRisk'
  import SectionKeyFieldsConflict from '../itemsSections/SectionKeyFieldsConflict'

  export default {
    name: 'rightSection',
    components: {
      SectionConstructor,
      SectionAssessmentRisk,
      SectionConflict,
      SectionKeyFieldsConflict
    },
    props: {
      activeTask: {
        type: Object,
        default: () => {}
      },
      taskInfo: {
        type: Object,
        default: () => {}
      }
    },
    methods: {
      getComponentName (name) {
        switch (name) {
          case 'constructor':
            return 'SectionConstructor'

          case 'conflict':
            return 'SectionConflict'

          case 'keyConflict':
            return 'SectionKeyFieldsConflict'

          case 'assessment':
            return 'SectionAssessmentRisk'
        }
      }
    }
  }
</script>

<style lang="scss" scoped>
  .task-monitor-section-wrapper {

    // Это решение кажется интересным, нужно предложить испытать
    // position: sticky;
    // top: 65px;
    // height: calc(100vh - 65px);
    // overflow-x: scroll;

    padding: 40px 0;

    &::after {
      pointer-events: none;
      content: '';
      position: absolute;
      top: 0;
      right: 0;
      bottom: 0;
      left: 0;
      background: transparent;
      transition: all 1s linear;
    }

    &.is-loading::after {
      background: $background-white;
      transition: all 0.2s linear;
      z-index: 11;
    }
  }
</style>
